{% extends 'bootstrap/base.html' %}

{% block styles %}
<link rel="stylesheet"
      href="{{ url_for('static', filename='bootstrap.min_black.css') }}">
{% endblock %}

{% block title %}
    {% if title %}{{ title }} - uBlog{% else %}Welcome to uBblog{% endif %}
{% endblock %}

{% block head %}
	{{ super() }}
	<link rel="shortcut icon" href="{{ url_for('static', filename='images/avatars.jpg') }}" type="image/x-icon">
	<link rel="shortcut" href="{{ url_for('static', filename='images/avatars.jpg') }}" type="image/x-icon">
{% endblock %}

{% block scripts %}
    {{ super() }}
    {{ moment.include_moment() }}
    {{ fontawesome_html() }}
    <script>
        $(function () {
            var timer = null;
            var xhr = null;
            $('.user_popup').hover(
                function(event) {
                    // mouse in event handler
                    var elem = $(event.currentTarget);
                    var usr = $(this).attr('id')
                    timer = setTimeout(function() {
                        timer = null;
                        xhr = $.ajax(
                            '/user/' + usr + '/popup').done(
                                function(data) {
                                    xhr = null;
                                    elem.popover({
                                        trigger: 'manual',
                                        html: true,
                                        animation: false,
                                        container: elem,
                                        content: data
                                    }).popover('show');
                                    flask_moment_render_all();
                                }
                            );
                    }, 500);
                },
                function(event) {
                    // mouse out event handler
                    var elem = $(event.currentTarget);
                    if (timer) {
                        clearTimeout(timer);
                        timer = null;
                    }
                    else if (xhr) {
                        xhr.abort();
                        xhr = null;
                    }
                    else {
                        elem.popover('dispose');
                    }
                }
            );
        });
        function set_message_count(n) {
            $('#message_count').text(n);
            if (n > 0) {$('#message_count').removeClass('d-none'); console.log(n);}
            else {$('#message_count').addClass('d-none'); console.log(n);}
        }
        {% if current_user.is_authenticated %}
        $(function() {
            var since = 0;
            setInterval(function() {
                $.ajax('{{ url_for('main.notifications') }}?since=' + since).done(
                    function(notifications) {
                        for (var i = 0; i < notifications.length; i++) {
                            if (notifications[i].name == 'unread_message_count')
                                set_message_count(notifications[i].data);
                            since = notifications[i].timestamp;
                        }
                    }
                );
            }, 10000);
        });
        {% endif %}
    </script>
{% endblock %}

{% block navbar %}
<nav class="navbar navbar-dark navbar-expand-lg bg-primary">
    <div class="container">
        <a class="navbar-brand" href="{{ url_for('main.index') }}"><span class="text-info">&lt;</span> µBlog <span class="text-info">&gt;</span></a>
        <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapse"
                aria-controls="navbar-collapse" aria-expanded="false" aria-label="Toggle navigation">
            <span class="navbar-toggler-icon"></span>
        </button>

        <div class="collapse navbar-collapse" id="navbar-collapse">
            <ul class="navbar-nav mr-auto">
            {% if current_user.is_authenticated %}
                <li class="nav-item{% if request.path in ['/', '/index'] %} active{% endif %}">
                    <a class="nav-link" href="{{ url_for('main.index') }}">Home</a></li>
                <li class="nav-item {% if request.path in ['/explore'] %} active{% endif %}">
                    <a class="nav-link" href="{{ url_for('main.explore') }}">Explore</a></li>
<!--                <li class="nav-item {% if request.path in ['/stat'] %} active{% endif %}">-->
<!--                    <a class="nav-link" href="{{ url_for('main.stat') }}">Statistic</a></li>-->
            {% endif %}
                <li class="nav-item {% if request.path in ['/about'] %} active{% endif %}">
                    <a class="nav-link" href="{{ url_for('main.about') }}">About</a></li>
            </ul>
<!--                Right menu-->
            <ul class="navbar-nav">
                {% if g.search_form %}
                <form class="navbar-form" method="get" action="{{ url_for('main.search') }}">
                    <div class="input-group" style="margin-top: 2px">
                            {{ g.search_form.q(class='form-control',
                            placeholder=g.search_form.q.label.text) }}
                            <button class="btn btn-primary" type="submit">
                                <i class="fa fa-search" aria-hidden="true"></i>
                            </button>
                    </div>
                </form>
                {% endif %}
                {% if not current_user.is_authenticated %}
                <li class="nav-item"><a class="nav-link" href="{{ url_for('auth.login') }}">Login</a></li>
                {% else %}
                <li class="nav-item {% if request.path in ['/messages'] %} active{% endif %}">
                    <a class="nav-link" href="{{ url_for('main.messages') }}"><i class="fas fa-envelope fa-lg"></i>
                    {% set new_messages = current_user.new_messages() %}
                    <span id="message_count" class="badge badge-pill {% if not new_messages %} d-none{% endif %}
                        badge-warning">{{ new_messages }}</span>
                    </a>
                </li>
                <li class="nav-item dropdown">
                    <a class="nav-link dropdown-toggle" href="#" id="navbardrop"
                       role="button" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <img src="{{ current_user.avatar(40) }}" class="rounded-circle my-n3"/>
                    </a>
                    <div class="dropdown-menu dropdown-menu-right" aria-labelledby="navbardrop">
                        <h6 class="text-info dropdown-header">{{ current_user.username }}</h6>
                        <a class="dropdown-item"
                           href="{{ url_for('main.user', username=current_user.username) }}">Profile</a>
                        <div class="dropdown-divider"></div>
                        <a class="dropdown-item" href="{{ url_for('auth.logout') }}">Logout</a>
                    </div>
                </li>
                {% endif %}
            </ul>
        </div>
    </div>
</nav>
{% endblock %}

{% block content %}
    <div class="container">
        {% with messages = get_flashed_messages() %}
        {% if messages %}
        {% for message in messages %}
        <div class="alert alert-info alert-dismissible fade show" role="alert">
            <button type="button" class="close" data-dismiss="alert" aria-label="Close">
                <span aria-hidden="true">&times;</span>
            </button>
            {{ message }}
        </div>
        {% endfor %}
        {% endif %}
        {% endwith %}

        {# application content needs to be provided in the app_content block #}
        {% block app_content %}{% endblock %}
    </div>
{% endblock %}

